package Fichiers;

import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;

public class InOut{
    private ArrayList aSauver;
    private ArrayList ramene;
    private Container c;
    private int prochaineDonneALire;
    
    public InOut(Container c){
        aSauver = new ArrayList();
        ramene = new ArrayList();
        prochaineDonneALire = -1;
        this.c = c;// le getContentPane de la fenetre d'appel
    }
    
    private void sauver(String nomFichier) throws IOException{
        boolean fichierCree = true;
        FileWriter writer = null;
        try{
            writer = new FileWriter(nomFichier);
        }catch(FileNotFoundException e){
            fichierCree = false;
            throw e;
        }
        
        if (fichierCree){
            PrintWriter aCreer = new PrintWriter(writer);
            for (int i = 0; i < aSauver.size(); i++){
                aCreer.println((String)aSauver.get(i));
            }
            aCreer.close();
            aSauver.clear();
        }
    }
    
    private void lire(String nomFichier) throws IOException{
        boolean fichierExiste = true;
        boolean finFichier = false;
        FileReader lecteur = null;
        try{
            lecteur = new FileReader(nomFichier);
        }catch(FileNotFoundException e){
            fichierExiste = false;
            throw e;
        }
        
        if (fichierExiste){
            ramene.clear();
            BufferedReader entree = new BufferedReader(lecteur);
            while(! finFichier){
                String donnee = entree.readLine();
                if (donnee == null){
                    finFichier = true;
                }else{
                    ramene.add(donnee);
                }
            }
            entree.close();
            prochaineDonneALire = 0;
        }
    }
    
    private String trouverNomFichier(String message, boolean sauver){
        String nomDefaut = null, nomFichier = null;
        JFileChooser chooser = new JFileChooser();
        if (sauver){
            chooser.setApproveButtonText("Enregistrer");
            chooser.setDialogType(JFileChooser.SAVE_DIALOG);
        }else{
            chooser.setApproveButtonText("Ouvrir");
            chooser.setDialogType(JFileChooser.OPEN_DIALOG);
        }
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("txt");
        chooser.setDialogTitle(message);
        filter.setDescription("Fichiers de texte");
        chooser.setFileFilter(filter);
        int returnVal;
        if (sauver){
            returnVal = chooser.showSaveDialog(c);
        }else{
            returnVal = chooser.showOpenDialog(c);
        }
        if (returnVal == JFileChooser.APPROVE_OPTION){
            nomDefaut = chooser.getSelectedFile().getName();
        }
        if (nomDefaut != null){
            if (nomDefaut.indexOf(".txt") == -1){
                nomDefaut = nomDefaut + ".txt";
            }
            File f = chooser.getCurrentDirectory();
            nomFichier = f.getAbsolutePath() + f.separator + nomDefaut;
        }
        else{
            nomFichier = null;
        }
        return nomFichier;
    }
    
    public String trouverNomFichierImage(String message, boolean sauver){
        String nomDefaut = null, nomFichier = null;
        JFileChooser chooser = new JFileChooser();
        if (sauver){
            chooser.setApproveButtonText("Enregistrer");
            chooser.setDialogType(JFileChooser.SAVE_DIALOG);
        }else{
            chooser.setApproveButtonText("Ouvrir");
            chooser.setDialogType(JFileChooser.OPEN_DIALOG);
        }
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("jpg");
        filter.addExtension("gif");
        filter.addExtension("png");
        chooser.setDialogTitle(message);
        filter.setDescription("Fichiers images");
        chooser.setFileFilter(filter);
        int returnVal;
        if (sauver){
            returnVal = chooser.showSaveDialog(c);
        }else{
            returnVal = chooser.showOpenDialog(c);
        }
        if (returnVal == JFileChooser.APPROVE_OPTION){
            nomDefaut = chooser.getSelectedFile().getName();
        }
        if (nomDefaut != null){
            File f = chooser.getCurrentDirectory();
            nomFichier = f.getAbsolutePath() + f.separator + nomDefaut;
        }
        else{
            nomFichier = null;
        }
        return nomFichier;
    }
    
    public void sauverDonnees(String message)throws IOException{
        String nomDefaut = trouverNomFichier(message, true);
        if (nomDefaut != null){
            sauver(nomDefaut);
        }else{
            // prvenir que c'est incorrect
        }
    }
    
    public void lireFichier(String message)throws IOException{
        String nomDefaut = trouverNomFichier(message, false);
        if (nomDefaut != null){
                lire(nomDefaut);
        }else{
            //avertir impossibilit de lire.
        }
    }
    
    public void ajouterDonnee(String donnee){
        aSauver.add(donnee);
    }
    
    public String lireDonnee(int i){
        if (i+1 < ramene.size()){
            prochaineDonneALire = i+1;
        }else{
            prochaineDonneALire = -1;
        }
        return (String) ramene.get(i);
    }
    
    public String lireDonneeSuivante(){
        if (prochaineDonneALire != -1){
            return (String) ramene.get(prochaineDonneALire);
        }
        return null;
    }
    
    public void viderDonneesASauver(){
        aSauver.clear();
    }
    
    public void viderDonneesLues(){
        ramene.clear();
    }
    
    public int tailleDonneesASauver(){
        return aSauver.size();
    }
    
    public int tailleDonneesLues(){
        return ramene.size();
    }
    
    public void rembobiner(){
        if (ramene.size()>0){
            prochaineDonneALire = 0;
        }else{
            prochaineDonneALire = -1;
        }
    }
}