import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class Glissiere extends JPanel
                         implements ChangeListener {
    //Champ pour la valeur de la rgle
    JTextField textField;
    //La rgle.
    JSlider laRegle;
    int nbDec;
    int facteur;
    int maximum;
    int minimum;

    public Glissiere(String legende, double min, double max, double valInit, int nbDec) {
        if (nbDec < 0){nbDec = 0;}
        this.nbDec = nbDec;
        facteur = (int) Math.pow(10, nbDec);
        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        //Crer le label.
        JLabel sliderLabel = new JLabel(legende + ": ", JLabel.CENTER);
        sliderLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
        textField = new Champ(this);
        textField.setColumns(10); //de l'espace
        textField.setEnabled(true);  //  modifier pour champ permettre un input
        textField.setDisabledTextColor(Color.black);
        //Crer la rgle.
        minimum = (int) (min * facteur);
        maximum = (int) (max * facteur);
        int posDebut = (int) (valInit * facteur);
        min = (double) minimum / facteur;
        max = (double) maximum / facteur;
        valInit = (double) posDebut / facteur;
        if (nbDec > 0){
            textField.setText("" + valInit);
        } else{
            textField.setText("" + posDebut);
        }
        laRegle = new JSlider(JSlider.HORIZONTAL,
                                      minimum, maximum, posDebut);
        laRegle.addChangeListener(this);

        //Ajouter les graduations.
        laRegle.setMajorTickSpacing(maximum - minimum);
        laRegle.setPaintTicks(true);
        // laRegle.setPaintTicks(true);
        
        // Personnalisation des tiquettes
        Hashtable labelTable = new Hashtable();
        if (nbDec == 0){
           labelTable.put(new Integer(minimum), new JLabel("" + (int)min));
           labelTable.put(new Integer(maximum), new JLabel("" + (int)max));
        } else {
            labelTable.put(new Integer(minimum), new JLabel("" + min));
            labelTable.put(new Integer(maximum), new JLabel("" + max));
        }
        laRegle.setLabelTable(labelTable);
        laRegle.setPaintLabels(true);
        laRegle.setBorder(
                BorderFactory.createEmptyBorder(0,0,10,0));

        //Crer un panneau pour le label et le text field.
        JPanel labelAndTextField = new JPanel(); //FlowLayout
        labelAndTextField.add(sliderLabel);
        labelAndTextField.add(textField);

        //Ajouter le tout.
        add(labelAndTextField);
        add(laRegle);// la regle
        setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    }
    
    public double getValue(){
        return (double)laRegle.getValue()/ facteur;
    }
    
    public void setValue(double d){
        int val = (int) Math.round(d * facteur);
        
        System.out.println(val);
        
        laRegle.setValue(val);
        if (nbDec > 0){
            textField.setText("" + (double)val /facteur);
        } else {
            System.out.println(val);
            textField.setText("" + val); // facteur = 1 dans ce cas
        }
    }
    
    public JSlider getSlider(){
        return laRegle;
    }
    
    public int getDecimales(){
        return nbDec;
    }
    
    public int getFacteur(){return facteur;}
    public int getMax(){return maximum;}
    public int getMin(){return minimum;}

    /** couteur de rgle. */
    public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
        int val = (int)source.getValue();
        if (nbDec > 0){
            textField.setText("" + (double)val / facteur); //update du champ texte
        } else {
            textField.setText("" + val); //update du champ texte
        }
    }   
}
